//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <vector>
#include <algorithm>

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;


std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

template <class T>
inline void PRINT_ELEMENTS (const T& coll, const char* optcstr="")
{
  typename T::const_iterator pos;
  std::cout << ToRus(optcstr);
  for (pos=coll.begin(); pos!=coll.end(); ++pos) {
    std::cout <<*pos <<' ';
  }
  std::cout << std::endl;
}


int main(int argc, char* argv[])
{
  vector<int> coll;

  //      coll 
  // -   
  back_insert_iterator<vector<int> > iter(coll);

  //       
  *iter = 1;
  iter++; 
  *iter = 2;
  iter++;
  *iter = 3;
  PRINT_ELEMENTS(coll,": ");

  //       
  // -  
  back_inserter(coll) = 44;
  back_inserter(coll) = 55;
  PRINT_ELEMENTS(coll,"  : ");

  //       
  //   
  // -       
  coll.reserve(2*coll.size()); 
  copy (coll.begin(), coll.end(),  //  
        back_inserter(coll));      //  
  PRINT_ELEMENTS(coll,": ");

  getch();
  return 0;
}

//---------------------------------------------------------------------------